<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  
  
  <title>JavaScript Sort | Hexo</title>
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="In JavaScript, we can sort data by using sort method. We can use sort for sorting  Strings Numbers Dates  Lets looks at every topic. Sorting NumbersIn JavaScript, the array.sort() method sorts the arr">
<meta property="og:type" content="article">
<meta property="og:title" content="JavaScript Sort">
<meta property="og:url" content="http://example.com/2021/12/22/sort-method/index.html">
<meta property="og:site_name" content="Hexo">
<meta property="og:description" content="In JavaScript, we can sort data by using sort method. We can use sort for sorting  Strings Numbers Dates  Lets looks at every topic. Sorting NumbersIn JavaScript, the array.sort() method sorts the arr">
<meta property="og:locale" content="en_US">
<meta property="article:published_time" content="2021-12-22T06:19:40.000Z">
<meta property="article:modified_time" content="2021-12-22T06:26:14.136Z">
<meta property="article:author" content="John Doe">
<meta name="twitter:card" content="summary">
  
    <link rel="alternate" href="/atom.xml" title="Hexo" type="application/atom+xml">
  
  
    <link rel="shortcut icon" href="/favicon.png">
  
  
    
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/typeface-source-code-pro@0.0.71/index.min.css">

  
  
<link rel="stylesheet" href="/css/style.css">

  
    
<link rel="stylesheet" href="/fancybox/jquery.fancybox.min.css">

  
<meta name="generator" content="Hexo 5.4.0"></head>

<body>
  <div id="container">
    <div id="wrap">
      <header id="header">
  <div id="banner"></div>
  <div id="header-outer" class="outer">
    <div id="header-title" class="inner">
      <h1 id="logo-wrap">
        <a href="/" id="logo">Hexo</a>
      </h1>
      
    </div>
    <div id="header-inner" class="inner">
      <nav id="main-nav">
        <a id="main-nav-toggle" class="nav-icon"></a>
        
          <a class="main-nav-link" href="/">Home</a>
        
          <a class="main-nav-link" href="/archives">Archives</a>
        
      </nav>
      <nav id="sub-nav">
        
          <a id="nav-rss-link" class="nav-icon" href="/atom.xml" title="RSS Feed"></a>
        
        <a id="nav-search-btn" class="nav-icon" title="Search"></a>
      </nav>
      <div id="search-form-wrap">
        <form action="//google.com/search" method="get" accept-charset="UTF-8" class="search-form"><input type="search" name="q" class="search-form-input" placeholder="Search"><button type="submit" class="search-form-submit">&#xF002;</button><input type="hidden" name="sitesearch" value="http://example.com"></form>
      </div>
    </div>
  </div>
</header>

      <div class="outer">
        <section id="main"><article id="post-sort-method" class="h-entry article article-type-post" itemprop="blogPost" itemscope itemtype="https://schema.org/BlogPosting">
  <div class="article-meta">
    <a href="/2021/12/22/sort-method/" class="article-date">
  <time class="dt-published" datetime="2021-12-22T06:19:40.000Z" itemprop="datePublished">2021-12-22</time>
</a>
    
  </div>
  <div class="article-inner">
    
    
      <header class="article-header">
        
  
    <h1 class="p-name article-title" itemprop="headline name">
      JavaScript Sort
    </h1>
  

      </header>
    
    <div class="e-content article-entry" itemprop="articleBody">
      
        <p>In JavaScript, we can sort data by using sort method. We can use sort for sorting</p>
<ul>
<li>Strings</li>
<li>Numbers</li>
<li>Dates</li>
</ul>
<p>Lets looks at every topic.</p>
<h2 id="Sorting-Numbers"><a href="#Sorting-Numbers" class="headerlink" title="Sorting Numbers"></a>Sorting Numbers</h2><p>In JavaScript, the array.sort() method sorts the array. In following ways we sort the numbers using array.sort() method.</p>
<h4 id="Without-Arguments"><a href="#Without-Arguments" class="headerlink" title="Without Arguments"></a>Without Arguments</h4><p>The array.sort() methods sorts the array and returns the array of sorted values. By default it sorts in ascending order and mutates the array and returns.</p>
<p>Try this with an example</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">let numbers = [3,2,1];</span><br><span class="line"></span><br><span class="line">console.log(numbers.sort()) // returns [1,2,3]</span><br></pre></td></tr></table></figure>

<p>We get an array of numbers which are in ascending order. Lets try this with anothe example</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">let numbers2 = [2,100,5]</span><br><span class="line">console.log(numbers2.sort()) // returns [ 100, 2, 5 ]</span><br></pre></td></tr></table></figure>
<p>It gives an array in ascending but it is not looking like an array of numbers which are in ascending order. What actually happening in the background is when called without arguments, the array items are converting to strings and then comparing their sequences of uni-code point values.</p>
<h4 id="With-Arguments"><a href="#With-Arguments" class="headerlink" title="With Arguments"></a>With Arguments</h4><p>Sort method accepts arguments as well. we can use comparing functions as arguments to sort method. By using these comparing functions we sort the value as desired manner.</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br></pre></td><td class="code"><pre><span class="line">const numbers = [2, 100, 5];</span><br><span class="line">numbers.sort((a, b) =&gt; &#123;</span><br><span class="line">  if (a &lt; b) &#123;</span><br><span class="line">    return -1;</span><br><span class="line">  &#125;</span><br><span class="line">  if (a &gt; b) &#123;</span><br><span class="line">    return 1;</span><br><span class="line">  &#125;</span><br><span class="line">  return 0;</span><br><span class="line">&#125;); // =&gt; [2, 5, 100]</span><br></pre></td></tr></table></figure>
<p>Now we can see that the numbers are correctly sorted in ascending order.</p>
<h2 id="Sorting-Strings"><a href="#Sorting-Strings" class="headerlink" title="Sorting Strings"></a>Sorting Strings</h2><p>In JavaScript, sort method sorting the according to alphabetical order i.e it converts the given elements into strings by comparing the UTF-16 code sequences into unit values. Let’s look at an example</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">let names = [&#x27;smith&#x27;, &#x27;john&#x27;, &#x27;mithchel&#x27;, &#x27;harry&#x27;];</span><br><span class="line">&#x27;</span><br><span class="line">names.sort();</span><br><span class="line"></span><br><span class="line">// returns [ &#x27;harry&#x27;, &#x27;john&#x27;, &#x27;mithchel&#x27;, &#x27;smith&#x27; ]</span><br></pre></td></tr></table></figure>

<p>The sort() method sorts elements with the smallest unicode value at the start and largest at last. We can pass comparing functions as optional parameters to sort method to define customized sorting order.</p>
<p>We can sort the array of objects using their property names by passing a comparing function to the sort method.</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br></pre></td><td class="code"><pre><span class="line">const persons = [</span><br><span class="line">  &#123; id:1, name: &#x27;mithchel&#x27;&#125;,</span><br><span class="line">  &#123; id:2, name: &#x27;smith&#x27;&#125;,</span><br><span class="line">  &#123; id:3, name: &#x27;john&#x27;&#125;,</span><br><span class="line">  &#123; id:4, name: &#x27;harry&#x27;&#125;,</span><br><span class="line">];</span><br><span class="line"></span><br><span class="line">// sort by name</span><br><span class="line">items.sort(function (a, b) &#123;</span><br><span class="line">  return b.name - a.name;</span><br><span class="line">&#125;);</span><br></pre></td></tr></table></figure>

<p>The above example shows how to sort an array of objects in descending order using sort method by passing comparing function as argument.</p>
<h2 id="Sorting-Dates"><a href="#Sorting-Dates" class="headerlink" title="Sorting Dates"></a>Sorting Dates</h2><p>By using sort method, we can sort dates as well. Let’s look at an example</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br></pre></td><td class="code"><pre><span class="line">const tasks = [</span><br><span class="line">    &#123; id:1, taskName: &#x27;Writing&#x27;, date: &#x27;2019-06-28&#x27; &#125;,</span><br><span class="line">    &#123; id:3, taskName: &#x27;Skeetching&#x27;, date: &#x27;2019-06-10&#x27; &#125;,</span><br><span class="line">    &#123; id:4, taskName: &#x27;Dancing&#x27;, date: &#x27;2019-06-22&#x27; &#125;</span><br><span class="line">  ];</span><br><span class="line"></span><br><span class="line">  const sortedTasks = tasks.sort((a,b) =&gt; &#123;</span><br><span class="line">      return a.date - b.date;</span><br><span class="line">  &#125;);</span><br></pre></td></tr></table></figure>

<p>In above example we observe that there is an array of tasks which each one has a date string with a value. If we try to use sort method using a comparing function, it does not sort the array because unicoded value of each one is same. The returned sorted array looks like the same as sorted array.</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">[</span><br><span class="line">  &#123; id: 1, taskName: &#x27;Writing&#x27;, date: &#x27;2019-06-28&#x27; &#125;,</span><br><span class="line">  &#123; id: 3, taskName: &#x27;Skeetching&#x27;, date: &#x27;2019-06-10&#x27; &#125;,</span><br><span class="line">  &#123; id: 4, taskName: &#x27;Dancing&#x27;, date: &#x27;2019-06-22&#x27; &#125;</span><br><span class="line">]</span><br></pre></td></tr></table></figure>

<p>We have to convert the date string into date format to do sort operation.</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br></pre></td><td class="code"><pre><span class="line">const tasks = [</span><br><span class="line">    &#123; id:1, taskName: &#x27;Writing&#x27;, date: &#x27;2019-06-28&#x27; &#125;,</span><br><span class="line">    &#123; id:3, taskName: &#x27;Skeetching&#x27;, date: &#x27;2019-06-10&#x27; &#125;,</span><br><span class="line">    &#123; id:4, taskName: &#x27;Dancing&#x27;, date: &#x27;2019-06-22&#x27; &#125;</span><br><span class="line">  ];</span><br><span class="line"></span><br><span class="line">  const sortedTasks = tasks.sort((a,b) =&gt; &#123;</span><br><span class="line">      return new Date(a.date) - new Date(b.date);</span><br><span class="line">  &#125;);</span><br></pre></td></tr></table></figure>
<p>The above code returns the sorted array in ascending format. In this example, JavaScript implicitly converts the date string and compare the unicode of each property in array and returns the sorted array.</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">[</span><br><span class="line">  &#123; id: 3, taskName: &#x27;Skeetching&#x27;, date: &#x27;2019-06-10&#x27; &#125;,</span><br><span class="line">  &#123; id: 4, taskName: &#x27;Dancing&#x27;, date: &#x27;2019-06-22&#x27; &#125;,</span><br><span class="line">  &#123; id: 1, taskName: &#x27;Writing&#x27;, date: &#x27;2019-06-28&#x27; &#125;</span><br><span class="line">]</span><br></pre></td></tr></table></figure>


<h2 id="Note"><a href="#Note" class="headerlink" title="Note"></a>Note</h2><ul>
<li>We can customize the order of sorting by using comparing functions.</li>
<li>Sort method converts the value into string and compares uni-code point values.</li>
<li>By default, sort methods sorts the array in ascending order.</li>
</ul>

      
    </div>
    <footer class="article-footer">
      <a data-url="http://example.com/2021/12/22/sort-method/" data-id="ckxh5d8a00000rf6qgcsd8slm" data-title="JavaScript Sort" class="article-share-link">Share</a>
      
      
      
    </footer>
  </div>
  
    
<nav id="article-nav">
  
    <a href="/2021/12/22/chaining/" id="article-nav-newer" class="article-nav-link-wrap">
      <strong class="article-nav-caption">Newer</strong>
      <div class="article-nav-title">
        
          Higher Order Function Chaining in JavaScript
        
      </div>
    </a>
  
  
</nav>

  
</article>


</section>
        
          <aside id="sidebar">
  
    

  
    

  
    
  
    
  <div class="widget-wrap">
    <h3 class="widget-title">Archives</h3>
    <div class="widget">
      <ul class="archive-list"><li class="archive-list-item"><a class="archive-list-link" href="/archives/2021/12/">December 2021</a></li></ul>
    </div>
  </div>


  
    
  <div class="widget-wrap">
    <h3 class="widget-title">Recent Posts</h3>
    <div class="widget">
      <ul>
        
          <li>
            <a href="/2021/12/22/chaining/">Higher Order Function Chaining in JavaScript</a>
          </li>
        
          <li>
            <a href="/2021/12/22/sort-method/">JavaScript Sort</a>
          </li>
        
      </ul>
    </div>
  </div>

  
</aside>
        
      </div>
      <footer id="footer">
  
  <div class="outer">
    <div id="footer-info" class="inner">
      
      &copy; 2021 John Doe<br>
      Powered by <a href="https://hexo.io/" target="_blank">Hexo</a>
    </div>
  </div>
</footer>

    </div>
    <nav id="mobile-nav">
  
    <a href="/" class="mobile-nav-link">Home</a>
  
    <a href="/archives" class="mobile-nav-link">Archives</a>
  
</nav>
    


<script src="/js/jquery-3.4.1.min.js"></script>



  
<script src="/fancybox/jquery.fancybox.min.js"></script>




<script src="/js/script.js"></script>





  </div>
</body>
</html>